$Game::MaxQuota::Schedules = 99999999; 
$Pref::Server::Quota::Schedules = 99999999;

exec("Add-ons/Server_3DPlatformer/prefs.cs");
exec("add-ons/server_3Dplatformer/client.cs");

function eulerToAxis(%euler) // Credit to Trader for this
{
	%euler = vectorScale(%euler,$pi/180);
	%matrix = matrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

function GameConnection::setplatformercamera ( %this, %direction, %pitch, %minDist, %yawOffset )
	{
	//i stole all the event_2dcamera function code from Electrk with the intention that i was just going to package it to fix it in
	//as it turns out packages don't work that way
	//i don't think that add-on will ever be updated again, but if it does it shouldn't be too hard to fix this
		
	%camera = %this.camera;

	if ( !isObject(%player = %this.player)  ||  !isObject(%camera) )
	{
		return;
	}

	if ( %direction > 8  ||  %direction < 0 )
	{
		%this.setControlObject (%player);
		return;
	}

	if ( %direction $= "" )
	{
		%direction = 0;
	}

	if ( %pitch $= "" )
	{
		%pitch = 0;
	}

	if ( %minDist $= "" )
	{
		%minDist = 0;
	}

	if ( %yawOffset $= "" )
	{
		%yawOffset = 0;
	}


	// eulerToAxis breaks when the pitch is divisible by 90 but not divisible by 180

	if ( %pitch > 0  &&  %pitch % 90 == 0  &&  %pitch % 180 != 0 )  
	{
		%pitch--;
	}

	// Modulus doesn't like negative numbers

	if ( %pitch < 0  &&  mAbs(%pitch) % 90 == 0  &&  mAbs(%pitch) % 180 != 0 )
	{
		%pitch++;
	}

	switch ( %direction )
	{
		// North
		case 1:
		%direction = -%pitch SPC "0" SPC 0 + %yawOffset;
		
		// South
		case 2:
		%direction = %pitch SPC "0" SPC 180 + %yawOffset;
	
		// East
		case 3:
		%direction = "0" SPC -%pitch SPC (-90 - %yawOffset);
		
		// West
		case 4:
		%direction = "0" SPC %pitch SPC (90 + %yawOffset);
			
		// Northeast
		case 5:
		%direction = -%pitch SPC -%pitch SPC (-45 - %yawOffset);
		
		// Northwest
		case 6:
		%direction = -%pitch SPC %pitch SPC (45 + %yawOffset);
	
		// Southeast
		case 7:
		%direction = %pitch SPC -%pitch SPC (-135 - %yawOffset);
	
		// Southwest
		case 8:
		%direction = %pitch SPC %pitch SPC (135 + %yawOffset);
	}

	%camera.setFlyMode();
	%camera.mode = "Observer";
	%camera.setTransform ( %player.getTransform() );
	%this.setControlObject (%camera);
	%camera.setControlObject (%player);
	%camera.setOrbitMode (%player, %camera.getPosition() SPC eulerToAxis(%direction), -%minDist, 0, 0, 0);
	%this.bottomPrint (" ", 1, true);  // To prevent the "1 observer(s) thing"
}

//epic coder mode starts here

function servercmdenableplatformer(%client)
{
	if (%client.isSuperAdmin == 1)
	{
		$PlatformerEnabled = 1;
		announce("Platformer Enabled");
	}
}

function servercmddisableplatformer(%client)
{
	if (%client.isSuperAdmin == 1)
	{
		$PlatformerEnabled = 0;
		announce("Platformer Disabled");
	}
}

function servercmdfacedirection(%client,%direction)
{
	//announce(%direction);
	%camera = %client.camera;
	%player = %client.player;
	if (%player)
	{
		%transform = %player.gettransform();
		%camtransform = %camera.gettransform();
		
		%a = getword(%transform,0);
		%b = getword(%transform,1);
		%c = getword(%transform,2);
		%d = getword(%camtransform,3);
		%e = getword(%camtransform,4);
		%f = getword(%camtransform,5);
		%g = getword(%camtransform,6);
		
		%temp = axistoeuler(%d @ " " @ %e @ " " @ %f @ " " @ %g);
		%temp = getword(%temp,2);
		%temp = %temp / 180;
		%dirmod = 3.14159 * %temp;
		
		switch$(%direction)
		{
		case("0 1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ 0 - %dirmod); //forward
		case("1 1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ 0.785395 - %dirmod); //forward right
		case("1 0"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ 1.57079 - %dirmod); //right
		case("1 -1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ 2.35618 - %dirmod); //backwards right
		case("0 -1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ 3.14159 - %dirmod); //backwards
		case("-1 -1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ -2.35618 - %dirmod); //backwards left
		case("-1 0"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ -1.57079 - %dirmod); //left
		case("-1 1"): %newtransform = (%a @ " " @ %b @ " " @ %c @ " " @ 0 @ " " @ 0 @ " " @ 1 @ " " @ -0.785395 - %dirmod); //forward left
		}
		
		%player.settransform(%newtransform);
	}
}

function servercmdadd2dbinds(%client,%direction,%distance,%height,%offset)
{
	if ($PlatformerEnabled == 1)
	{
	commandtoclient(%client,'add2dbinds',$PlatformerEnabled);
	%client.setplatformercamera(%direction,%distance,%height,%offset);
	}
}

function servercmdremove2dbinds(%client)
{
	commandtoclient(%client,'remove2dbinds');
	
	%camera = %client.camera;
	%player = %client.player;
	
	%client.setControlObject(%client.player);
	%camera.setControlObject(%client);
}


registerOutputEvent(GameConnection, SetPlatformerMode, "list None 0 North 1 South 2 East 3 West 4 Northeast 5 Northwest 6 Southeast 7 Southwest 8" TAB "string 200 170" TAB "string 200 170"  TAB "string 200 170" , 0);
function GameConnection::SetPlatformerMode(%client,%direction,%distance,%height,%offset)
{
	if (%direction != 0)
	{
		servercmdadd2dbinds(%client,%direction,%distance,%height,%offset);
	}
	else
	{
		servercmdremove2dbinds(%client);
	}
}

package Platformer_Server
{
	function GameConnection::spawnPlayer(%client)
	{	
		%result = parent::spawnPlayer(%client);
		servercmdremove2dbinds(%client);
	}
	
	function gameConnection::onDeath(%client,%sourceObject,%sourceClient,%damageType,%damageArea)
	{
		servercmdremove2dbinds(%client);
		Parent::onDeath(%client,%sourceObject,%sourceClient,%damageType,%damageArea);
	}
	
	function PlayerData::get2DCameraDirection ( %this ) //hotfix if event_2dcamera is enabled, without it everything will be broken. it might still break the playertypes though but you shouldn't need to use it for this.
	{
		if ( !%this.is2DPlayer )
		{
			return 0;
		}
	}
};
activatepackage ("Platformer_Server");